defmodule ChickenEgg.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    children = [
      # Start the Telemetry supervisor
      ChickenEggWeb.Telemetry,
      # Start the Ecto repository
      ChickenEgg.Repo,
      # Start the PubSub system
      {Phoenix.PubSub, name: ChickenEgg.PubSub},
      # Start Finch
      {Finch, name: ChickenEgg.Finch},
      # Start the Endpoint (http/https)
      ChickenEggWeb.Endpoint
      # Start a worker by calling: ChickenEgg.Worker.start_link(arg)
      # {ChickenEgg.Worker, arg}
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: ChickenEgg.Supervisor]
    Supervisor.start_link(children, opts)
  end

  # Tell Phoenix to update the endpoint configuration
  # whenever the application is updated.
  @impl true
  def config_change(changed, _new, removed) do
    ChickenEggWeb.Endpoint.config_change(changed, removed)
    :ok
  end
end
